/**
 * generated by Xtext 2.16.0
 */
package org.xtext.ungs.drake.drake;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Linear Expression</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.xtext.ungs.drake.drake.LinearExpression#getFactor <em>Factor</em>}</li>
 *   <li>{@link org.xtext.ungs.drake.drake.LinearExpression#getSimbol <em>Simbol</em>}</li>
 *   <li>{@link org.xtext.ungs.drake.drake.LinearExpression#getExpression <em>Expression</em>}</li>
 *   <li>{@link org.xtext.ungs.drake.drake.LinearExpression#getValue <em>Value</em>}</li>
 * </ul>
 *
 * @see org.xtext.ungs.drake.drake.DrakePackage#getLinearExpression()
 * @model
 * @generated
 */
public interface LinearExpression extends EObject
{
  /**
   * Returns the value of the '<em><b>Factor</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Factor</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Factor</em>' containment reference.
   * @see #setFactor(Factor)
   * @see org.xtext.ungs.drake.drake.DrakePackage#getLinearExpression_Factor()
   * @model containment="true"
   * @generated
   */
  Factor getFactor();

  /**
   * Sets the value of the '{@link org.xtext.ungs.drake.drake.LinearExpression#getFactor <em>Factor</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Factor</em>' containment reference.
   * @see #getFactor()
   * @generated
   */
  void setFactor(Factor value);

  /**
   * Returns the value of the '<em><b>Simbol</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Simbol</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Simbol</em>' attribute.
   * @see #setSimbol(String)
   * @see org.xtext.ungs.drake.drake.DrakePackage#getLinearExpression_Simbol()
   * @model
   * @generated
   */
  String getSimbol();

  /**
   * Sets the value of the '{@link org.xtext.ungs.drake.drake.LinearExpression#getSimbol <em>Simbol</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Simbol</em>' attribute.
   * @see #getSimbol()
   * @generated
   */
  void setSimbol(String value);

  /**
   * Returns the value of the '<em><b>Expression</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Expression</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Expression</em>' containment reference.
   * @see #setExpression(LinearExpression)
   * @see org.xtext.ungs.drake.drake.DrakePackage#getLinearExpression_Expression()
   * @model containment="true"
   * @generated
   */
  LinearExpression getExpression();

  /**
   * Sets the value of the '{@link org.xtext.ungs.drake.drake.LinearExpression#getExpression <em>Expression</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Expression</em>' containment reference.
   * @see #getExpression()
   * @generated
   */
  void setExpression(LinearExpression value);

  /**
   * Returns the value of the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Value</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Value</em>' attribute.
   * @see #setValue(int)
   * @see org.xtext.ungs.drake.drake.DrakePackage#getLinearExpression_Value()
   * @model
   * @generated
   */
  int getValue();

  /**
   * Sets the value of the '{@link org.xtext.ungs.drake.drake.LinearExpression#getValue <em>Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Value</em>' attribute.
   * @see #getValue()
   * @generated
   */
  void setValue(int value);

} // LinearExpression
